package cz.muni.fi.pb162.graphics;

/**
 * This class represents the point in 2D space.
 *
 * @author Jan Pavlovic
 * @author Petr Adamek
 */
public class Point implements Comparable<Point> {

    /** Coordinate x */
    private int x;
    /** Coordinate y */
    private int y;
    
    /**
     * Creates new point.
     * @param x coordinate x
     * @param y coordinate y
     */
    public Point(int x, int y) {
        this.x = x;
        this.y = y;
    }
    
    /**
     * Returns description of the points.
     * @return the position of the point
     */
    public String toString() {
        return "[" + x + ", " + y + "]";
    }
    
    /**
     * Returns coordinate x.
     * @return coordinate x
     */
    public int getX() {
        return x;
    }
    
    /**
     * Returns coordinate y.
     * @return coordinate y
     */
    public int getY() {
        return y;
    }
    
    public boolean equals(Object obj) {
        if (!(obj instanceof Point)) {
            return false;
        }
        Point p = (Point) obj;
        return (this.x == p.getX()) && (this.getY() == p.getY());
    }
    
    public int hashCode() {
        int hash = 1;
        hash = hash * 31 + x;
        hash = hash * 31 + y;
        return hash;
    }
    
    public int compareTo(Point other) {
        int dist = this.x - other.x;
        if (dist != 0) return dist;
        return this.y - other.y;
    }
}

























